<template>
  <div class="article-card">
    <div class="article-thumbnail-container">
      <div class="article-thumbnail">
        <a :href="article.link" target=_blank><img v-if="article.postImg" :src="article.postImg.url"/></a>
        <div class="thumbnail-over-layer">
          <p>{{ $t(`global.open`) | capitalize }} <v-icon name="external-link-alt"></v-icon></p>
        </div>
      </div>
    </div>
    <div class="article-description">
      <p class="mb-1 small">
        <span class="article-description-feed-label" @click="showEditSourceModal = true">
          <img :src="feedFavicon(feed.url)" class="feed-favicon"/>
          {{ feed.label }}
        </span>
        -
        <span class="article-description-category-label" @click="showEditCategoryModal = true" :style="'color: ' + category.color + ';'"><v-icon name="bookmark" scale="0.6"></v-icon> {{ category.label }}</span>
        <br/>
        <span class="text-muted">{{ new Date(article.pubDate).toLocaleDateString() }}</span>
      </p>
      <p class="mb-1">
        {{ article.title }}
      </p>
      <p class="mb-0">
        <a :href="article.link" target=_blank class="open-button">
          {{ $t(`global.open`) | capitalize }} <v-icon name="external-link-alt" scale=0.6></v-icon>
        </a>
      </p>
    </div>
    <edit-source-modal
      :v-model="showEditSourceModal"
      :feed="feed"
      @ok="showEditSourceModal = false"
      @cancel="showEditSourceModal = false"
    />
    <edit-category-modal
      :v-model="showEditCategoryModal"
      :category="category"
      @ok="showEditCategoryModal = false"
      @cancel="showEditCategoryModal = false"
    />
  </div>
</template>

<script>
import { BaseComponent } from '@/utils/'

import EditSourceModal from '@/components/elements/modals/EditSourceModal'
import EditCategoryModal from '@/components/elements/modals/EditCategoryModal'

export default {
  extends: BaseComponent,
  data () {
    return {
      thumbnailElement: null,
      resizeObserver: null,
      // thumbnailRatio: 16 / 9
      thumbnailRatio: 2,
      showEditCategoryModal: false,
      showEditSourceModal: false
    }
  },
  components: {
    EditSourceModal,
    EditCategoryModal
  },
  computed: {
    feed: function () {
      return this.findFeeds({ id: this.article.feedId }).pop() // Take first item
    },
    category: function () {
      return this.findCategories({ id: this.feed.category_id }).pop() // Take first item
    }
  },
  getters: {
    MyFeedsModule: [
      'findFeeds',
      'findCategories'
    ]
  },
  props: {
    article: Object
  },
  methods: {
    updateThumbnailSize: function () {
      const width = this.thumbnailElement.clientWidth
      const height = (width / this.thumbnailRatio)
      this.thumbnailElement.style.height = height + 'px'
      const image = this.thumbnailElement.querySelector('a img')
      if (image) {
        if (image.naturalWidth > width) {
          image.style.height = '100%'
        } else if (image.naturalHeight > height) {
          image.style.width = '100%'
        }
      }
    },
    feedFavicon: function (url) {
      return this.$h.getHostHttpUrl(url) + '/favicon.ico'
    }
  },
  mounted () {
    // Loop en child nodes and retrieve by classname 'ms_button_element'
    // Don't use this.$refs: because no need to create unique id to retrieve elements...
    this.thumbnailElement = this.$el.querySelector('.article-thumbnail')
    // Apply size based on ratio
    this.updateThumbnailSize()
    // Init resize observer
    this.resizeObserver = new ResizeObserver((entries) => {
      this.updateThumbnailSize()
    })
    this.resizeObserver.observe(this.thumbnailElement)
  },
  destroyed () {
    delete this.resizeObserver
  }
}
</script>

<style lang="scss">
.article-card {
  margin-bottom: $ms-margin-m;

  .article-thumbnail-container {
    padding-left: $ms-padding-xs;
    margin-bottom: $ms-margin-xs;
    border-left: 2px solid $__THEME_SECONDARY_COLOR__;

    .article-thumbnail {
      width: 100%;
      position: relative;
      border-radius: 0 4px 0 0;
      overflow: hidden;
      a {
        overflow: hidden;
        border-radius: 0 4px 0 0;
        width: 100%;
        height: 100%;
        display: flex;
        align-items: center;
        justify-content: center;
        background-color: $__THEME_SECONDARY_COLOR__;
        img {
          transform: scale(1);
          transition: all ease 400ms;
        }
      }
      .thumbnail-over-layer {
        width: 100%;
        height: 100%;
        background-color: rgba($__THEME_TERTIARY_COLOR__, 0.8);
        position: absolute;
        top: 0;
        left: 0;
        opacity: 0;
        transition: all ease 400ms;
        color: $__THEME_MS_BLUE_COLOR__;
        display: flex;
        justify-content: center;
        align-items: center;
        font-size: 1.2rem;
        cursor: pointer;
        pointer-events: none;
        background-image: repeating-linear-gradient(-45deg,
          rgba($__THEME_SECONDARY_COLOR__, 0.1),
          rgba($__THEME_SECONDARY_COLOR__, 0.1) 4px,
          rgba($__THEME_TERTIARY_COLOR__, 0.1) 4px,
          rgba($__THEME_TERTIARY_COLOR__, 0.1) 8px
        );
        p {
          display: block;
          .fa-icon {
            margin-top: -4px;
            margin-left: 4px;
          }
        }
      }
    }
  }

  .article-description {
    padding: $ms-padding-xs;
    margin-left: 10px;
    border-radius: 0 0 4px 0;
    background-color: $__THEME_SECONDARY_COLOR__;
    transition: all ease 400ms;
    .feed-favicon {
      width: 14px;
      height: 14px;
      margin-top: -4px;
    }
    .article-description-feed-label,
    .article-description-category-label {
      cursor: pointer;
      border-bottom-width: 1px;
      border-bottom-style: solid;
      border-bottom-color: transparent;
      transition: all ease 400ms;
      &:hover {
        border-bottom-color: inherit;
      }
    }
    .open-button {
      .fa-icon {
        margin-top: -2px;
      }
    }
  }

  &:hover {
    .article-thumbnail-container {
      .article-thumbnail {
        a img {
          transform: scale(1.1);
        }
        &:hover {
          .thumbnail-over-layer {
            opacity: 1;
          }
        }
      }
    }
    .article-description {
      background-color: $__THEME_TERTIARY_COLOR__;
    }
  }
}
</style>
